/*******************************************************************************
 * FoxRedeemHistoryUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxRedeemHistoryUI extends FoxUIBaseTransactionTask within FoxUI;

var transient string OfferGuidToRedeem;
var transient bool bShowWorkingDialog;
var transient bool bKillWorkingDialog;
var private transient bool bHasWorkingDialog;
var private const localized string RedeemingLabel;
var private const localized string RedeemingLabelCaps;
var private const localized string RedeemFailureLabel;
var private const localized string RedeemFailureLabelInvalidItem;
var delegate<PostRedeemHistory> __PostRedeemHistory__Delegate;

delegate PostRedeemHistory(bool bSuccess)
{
    //return;    
}

function bool StartTask()
{
    // End:0xE3
    if(super(FoxUIBaseTask).StartTask())
    {
        // End:0x32
        if(!ValidateRedeemHistory())
        {
            RedeemHistoryFailed(RedeemFailureLabelInvalidItem);
        }
        // End:0xE3
        else
        {
            Outer.ui_toggleCaptureInput(false);
            // End:0xD7
            if(!Outer.PCOwner.OnlineSub.StoreInterface.RedeemHistory(OfferGuidToRedeem))
            {
                RedeemHistoryComplete(false, OfferGuidToRedeem);
            }
            // End:0xE3
            else
            {
                ShowWorkingDialog();
                return true;
            }
        }
    }
    return false;
    //return ReturnValue;    
}

protected function bool ValidateRedeemHistory()
{
    return OfferGuidToRedeem != "";
    //return ReturnValue;    
}

protected function RegisterOnlineDelegates()
{
    Outer.PCOwner.OnlineSub.StoreInterface.AddRedeemHistoryCompleteDelegate(0, RedeemHistoryComplete);
    //return;    
}

protected function CleanupOnlineDelegates()
{
    Outer.PCOwner.OnlineSub.StoreInterface.ClearRedeemHistoryCompleteDelegate(0, RedeemHistoryComplete);
    //return;    
}

protected function NotifyProcessComplete(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    local FoxItemCacheInventory InventoryCache;

    Outer.CloseDialogBox();
    OnWorkingDialogHide();
    bHasWorkingDialog = false;
    // End:0x89
    if(class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache))
    {
        InventoryCache.MergeUpdatedItems();
    }
    super(FoxUIBaseTask).NotifyProcessComplete(Selection);
    PostRedeemHistory(Selection == 0);
    //return;    
}

protected function ShowWorkingDialog()
{
    local DialogBoxProperties Properties;

    // End:0x14A
    if(bShowWorkingDialog && !bHasWorkingDialog)
    {
        bHasWorkingDialog = true;
        // End:0x64
        if(__OnWorkingDialogShow__Delegate != none)
        {
            OnWorkingDialogShow(RedeemingLabelCaps);
            bShowWorkingDialog = false;
        }
        // End:0x14A
        else
        {
            Properties.DialogType = 0;
            Properties.TitleText = Outer.LocWorkingLabel;
            Properties.BodyText = RedeemingLabel;
            Properties.bShowTimer = true;
            Properties.bCloseOnButtonPress = false;
            Outer.ShowDialogBox(Properties);
        }
    }
    //return;    
}

protected function HideWorkingDialog()
{
    // End:0x4B
    if(bKillWorkingDialog)
    {
        Outer.CloseDialogBox();
        OnWorkingDialogHide();
        bHasWorkingDialog = false;
    }
    //return;    
}

protected function RedeemHistoryComplete(bool bSuccess, const string OfferGuid)
{
    Outer.ui_toggleCaptureInput(true);
    // End:0x56
    if(bSuccess && OfferGuid == OfferGuidToRedeem)
    {
        NotifyProcessComplete(0);
    }
    // End:0x69
    else
    {
        RedeemHistoryFailed(RedeemFailureLabel);
    }
    //return;    
}

private final function RedeemHistoryFailed(string ErrorText)
{
    local DialogBoxProperties Properties;

    ScriptTrace();
    Outer.CloseDialogBox();
    Properties.DialogType = 1;
    Properties.TitleText = Outer.LocFailureLabel;
    Properties.BodyText = ErrorText;
    Properties.OnDialogButtonPressed = NotifyProcessFailed;
    bHasWorkingDialog = false;
    Outer.ShowDialogBox(Properties);
    //return;    
}

defaultproperties
{
    bShowWorkingDialog=true
    bKillWorkingDialog=true
    RedeemingLabel="Redeeming items..."
    RedeemingLabelCaps="REDEEMING ITEMS..."
    RedeemFailureLabel="Unable to redeem items for unknown reason."
    RedeemFailureLabelInvalidItem="Unable to redeem invalid items."
}